
# Address width, on logic side (8 bits data access)
set b_addr_w 14

# Address width on AXI MM side (32 bits access)
set a_addr_w [expr $b_addr_w-2]

set a_depth [expr 1<<$a_addr_w]
set b_depth [expr 1<<$b_addr_w]

set xcipath [create_ip -name axi_bram_ctrl -vendor xilinx.com -library ip -version 4.1 -module_name combpm_packet_filter_axi_bram_ctrl]


set_property -dict [list \
    CONFIG.PROTOCOL {AXI4} \
    CONFIG.SUPPORTS_NARROW_BURST {0} \
    CONFIG.SINGLE_PORT_BRAM {1} \
    CONFIG.USE_ECC {0} \
    CONFIG.BMG_INSTANCE {EXTERNAL} \
    CONFIG.MEM_DEPTH $a_depth \
    CONFIG.CLKIF.FREQ_HZ 250000000 \
    CONFIG.DATA_WIDTH 32 \
    ] [get_ips combpm_packet_filter_axi_bram_ctrl]

set_property GENERATE_SYNTH_CHECKPOINT 0 [get_files $xcipath]

set xcipath [create_ip -name blk_mem_gen -vendor xilinx.com -library ip -version 8.4 -module_name combpm_packet_filter_blk_mem]

set_property -dict [list \
    CONFIG.Memory_Type {True_Dual_Port_RAM} \
    CONFIG.Use_Byte_Write_Enable {true} \
    CONFIG.Byte_Size {8} \
    CONFIG.Write_Width_A {32} \
    CONFIG.Write_Depth_A $a_depth \
    CONFIG.Read_Width_A {32} \
    CONFIG.Operating_Mode_A {WRITE_FIRST} \
    CONFIG.Write_Width_B {8} \
    CONFIG.Read_Width_B {8} \
    CONFIG.Operating_Mode_B {WRITE_FIRST} \
    CONFIG.Enable_B {Use_ENB_Pin} \
    CONFIG.Register_PortA_Output_of_Memory_Primitives {false} \
    CONFIG.Register_PortA_Output_of_Memory_Core {false} \
    CONFIG.Register_PortB_Output_of_Memory_Primitives {false} \
    CONFIG.Port_B_Clock {250} \
    CONFIG.Port_B_Write_Rate {0} \
    CONFIG.Port_B_Enable_Rate {100} \
    ] [get_ips combpm_packet_filter_blk_mem]

set_property GENERATE_SYNTH_CHECKPOINT 0 [get_files $xcipath]
